using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            ModAPI.RegisterTool<StrongSteelBindingTool>("Strong Steel Binding", "5 times stronger.", ModAPI.LoadSprite("Binding5xView.png", 1f, false), "Fixed cable");
            ModAPI.RegisterTool<StrongestSteelBindingTool>("Strongest Steel Binding", "10 times stronger.", ModAPI.LoadSprite("Binding10xView.png", 1f, false), "Fixed cable");
            ModAPI.RegisterTool<PhaseLinkToolDetailed>("Invisible Phase Link", "Comes from the OCM mod\nIt's only visible in detail view", ModAPI.LoadSprite("InvisiblePhaseLink.png", 1f, false), "Phase link");
            ModAPI.RegisterTool<StrongRopeTool>("Strong Rope", "10 times stronger", ModAPI.LoadSprite("Rope10xView.png", 1f, false), "Wire");

            ModAPI.RegisterPower<MutingPower>("Mute Power", "Comes from the Parts and Contraptions mod\nToggles the muting of objects", ModAPI.LoadSprite("MutePower.png", 1f, false));
            ModAPI.RegisterPower<InvisiblePower>("Invisibility Power", "Comes from the Parts and Contraptions mod\nToggles the invisibility of objects", ModAPI.LoadSprite("InvisiblePower.png", 1f, false));

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wooden Pole"),
                    NameOverride = "Log -QoLI",
                    NameToOrderByOverride = "Wooden Pole 2",
                    DescriptionOverride = "A version of a wooden pole that's not sharp",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("LogView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Log.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.2571429f, 3.714286f);
                        Collision1.offset = new Vector2(0f, 0f);

                        var prop = ModAPI.FindPhysicalProperties("Wood");
                        prop.Sharp = false;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wooden Pole"),
                    NameOverride = "Short Log -QoLI",
                    NameToOrderByOverride = "Wooden Pole 3",
                    DescriptionOverride = "A short version of the wooden pole that's not sharp",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("ShortLogView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ShortLog.png");

                        ModResources.SetMass(Instance, 1.6f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.2571429f, 0.8571429f);
                        Collision1.offset = new Vector2(0f, 0f);

                        var prop = ModAPI.FindPhysicalProperties("Wood");
                        prop.Sharp = false;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("I-Beam"),
                    NameOverride = "Small Pointless I-Beam -QoLI", //haha funny pointless joke haha
                    NameToOrderByOverride = "Small I-Beam 2",
                    DescriptionOverride = "A version of the small I-Beam without the edges, also has more textures",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("SmallIBeamPointlessView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("SmallIBeamPointlessA.png"),
                            ModAPI.LoadSprite("SmallIBeamPointlessB.png"),
                            ModAPI.LoadSprite("SmallIBeamPointlessC.png"),
                            ModAPI.LoadSprite("SmallIBeamPointlessD.png"),
                            ModAPI.LoadSprite("SmallIBeamPointlessE.png"),
                        };

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(1.228571f, 0.2571429f);
                        Collision1.offset = new Vector2(0f, 0f);

                        ModResources.SetMass(Instance, 5f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Structural Pillar"),
                    NameOverride = "Separator -QoLI",
                    NameToOrderByOverride = "Fuse 2",
                    DescriptionOverride = "An item similar to the activation fuse except it can't transfer activations and holds more weight.",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("SeparatorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Separator.png");

                        ModResources.SetMass(Instance, 5f);

                        Instance.GetOrAddComponent<SeparatorBehaviour>();

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("I-Beam"),
                    NameOverride = "Pointless I-Beam -QoLI",
                    NameToOrderByOverride = "I-Beam 2",
                    DescriptionOverride = "A version of the I-Beam without the edges, also has more textures",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("IBeamPointlessView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("IBeamPointlessA.png"),
                            ModAPI.LoadSprite("IBeamPointlessB.png"),
                            ModAPI.LoadSprite("IBeamPointlessC.png"),
                            ModAPI.LoadSprite("IBeamPointlessD.png"),
                            ModAPI.LoadSprite("IBeamPointlessE.png"),
                        };
                        ModResources.SetMass(Instance, 35f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(7.514286f, 0.2571429f);
                        Collision1.offset = new Vector2(0f, 0f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Structural Pillar"),
                    NameOverride = "Pointless Structural Pillar -QoLI",
                    NameToOrderByOverride = "Structural Pillar 2",
                    DescriptionOverride = "A version of the structural pillar without edges",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("PointlessStructuralPillarView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("PointlessStructuralPillar.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.2285714f, 2.085714f);
                        Collision1.offset = new Vector2(0f, 0f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Structural Pillar"),
                    NameOverride = "Structural Pillar with a Single Edge -QoLI",
                    NameToOrderByOverride = "Structural Pillar 3",
                    DescriptionOverride = "A version of the structural pillar with a singular edge",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("StructuralPillarOneEdgeView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("StructuralPillarOneEdge.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.2285714f, 2.085714f);
                        Collision1.offset = new Vector2(0.0002092719f, -0.04288936f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.2857143f, 0.08581758f);
                        Collision2.offset = new Vector2(0f, 1.042915f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("I-Beam"),
                    NameOverride = "Split I-Beam -QoLI",
                    NameToOrderByOverride = "I-Beam 3",
                    DescriptionOverride = "A version of the I-Beam that's been split in half", //This description used to be a terrible outdated meme
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("SplitBeamView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("SplitBeamA.png"),
                            ModAPI.LoadSprite("SplitBeamB.png"),
                            ModAPI.LoadSprite("SplitBeamC.png"),
                            ModAPI.LoadSprite("SplitBeamD.png"),
                            ModAPI.LoadSprite("SplitBeamE.png"),
                        };
                        ModResources.SetMass(Instance, 17.5f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(3.771429f, 0.2571429f);
                        Collision1.offset = new Vector2(0f, 0f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Generator Battery -QoLI",
                    NameToOrderByOverride = "Battery 2",
                    DescriptionOverride = "A version of the battery with the charge of a generator",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("GeneratorBatteryView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Battery.png");
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetOrAddComponent<NoTemperature>();

                        var Glow = Instance.GetOrAddComponent<CustomGlowBattery>();
                        Glow.Colour = new Color32(15, 140, 0, 100);
                        Glow.GlowSprite = ModAPI.LoadSprite("BatteryGlow.png");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.ForceNoChargeParticles = true;
                        phys.SimulateTemperature = false;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Industrial Battery -QoLI",
                    NameToOrderByOverride = "Battery 3",
                    DescriptionOverride = "A version of the battery with the charge of an industrial generator",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("IndustrialBatteryView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Battery.png");
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetOrAddComponent<NoTemperature>();

                        var Glow = Instance.GetOrAddComponent<CustomGlowBattery>();
                        Glow.TargetCharge = 950f;
                        Glow.GlowSprite = ModAPI.LoadSprite("BatteryGlow.png");
                        Glow.Colour = new Color32(200, 0, 0, 100);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.ForceNoChargeParticles = true;
                        phys.SimulateTemperature = false;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Infinite Battery -QoLI",
                    NameToOrderByOverride = "Battery 4",
                    DescriptionOverride = "Abuses the laws of physics to achieve an infinite charge\nSpawns with disabled collisions for good reasons",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("InfiniteBatteryView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("InfiniteBattery.png");
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetOrAddComponent<NoTemperature>();

                        var Glow = Instance.GetOrAddComponent<CustomGlowBattery>();
                        Glow.TargetCharge = float.MaxValue; //Not actually infinite
                        Glow.GlowSprite = ModAPI.LoadSprite("BatteryGlow.png");
                        Glow.Colour = new Color32(129, 14, 157, 255);

                        Instance.layer = 10; //cause it colliding can make stuff incapable of being moved or just breaks the map.

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.ForceNoChargeParticles = true;
                        phys.SimulateTemperature = false;
                        phys.Disintegratable = false;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Text Display"),
                    NameOverride = "Invisible Text Display -QoLI",
                    NameToOrderByOverride = "Text Display 2",
                    DescriptionOverride = "A text display that only shows the writing and the light",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("InvisibleTextDisplayView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("InvisibleTextDisplay.png");
                        Instance.GetOrAddComponent<FreezeBehaviour>();
                        Instance.layer = 10;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Metal Table -QoLI",
                    NameToOrderByOverride = "Wooden Table 2",
                    DescriptionOverride = "A table made of metal",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MetalTableView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MetalTable.png");

                        ModResources.SetMass(Instance, 2f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(2.057143f, 0.08571416f);
                        Collision1.offset = new Vector2(0f, 0.4285715f);
                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05714262f, 0.857143f);
                        Collision2.offset = new Vector2(-0.9142851f, -0.04285708f);
                        var Collision3 = Instance.AddComponent<BoxCollider2D>();
                        Collision3.size = new Vector2(0.05714262f, 0.857143f);
                        Collision3.offset = new Vector2(0.9142851f, -0.04285708f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Metal Chair -QoLI",
                    NameToOrderByOverride = "Wooden Chair 2",
                    DescriptionOverride = "A chair made of metal",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MetalChairView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MetalChair.png");

                        ModResources.SetMass(Instance, 1f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.0857144f, 0.885714f);
                        Collision1.offset = new Vector2(-0.2714285f, 0.2714287f);
                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.5428571f, 0.08571404f);
                        Collision2.offset = new Vector2(0.04285723f, -0.1285712f);
                        var Collision3 = Instance.AddComponent<BoxCollider2D>();
                        Collision3.size = new Vector2(0.05714273f, 0.5428575f);
                        Collision3.offset = new Vector2(-0.2285712f, -0.442857f);
                        var Collision4 = Instance.AddComponent<BoxCollider2D>();
                        Collision4.size = new Vector2(0.05714273f, 0.5428575f);
                        Collision4.offset = new Vector2(0.2285712f, -0.442857f);
                    }
                }
            );

            //Bed
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("I-Beam"),
                    NameOverride = "Bed -QoLI",
                    NameToOrderByOverride = "Bed",
                    DescriptionOverride = "A bed with many colors",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("BedView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("BedA.png"),
                            ModAPI.LoadSprite("BedB.png"),
                            ModAPI.LoadSprite("BedC.png"),
                            ModAPI.LoadSprite("BedD.png"),
                            ModAPI.LoadSprite("BedE.png"),
                            ModAPI.LoadSprite("BedF.png"),
                            ModAPI.LoadSprite("BedG.png"),
                            ModAPI.LoadSprite("BedH.png"),
                            ModAPI.LoadSprite("BedI.png"),
                        };

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        BoxCollider2D C1 = Instance.AddComponent<BoxCollider2D>();
                        C1.offset = new Vector2(0f, 0f);
                        C1.size = new Vector2(2.057143f, 0.2285719f);
                        BoxCollider2D C2 = Instance.AddComponent<BoxCollider2D>();
                        C2.offset = new Vector2(-0.8999996f, -0.1857142f);
                        C2.size = new Vector2(0.08571434f, 0.1428574f);
                        BoxCollider2D C3 = Instance.AddComponent<BoxCollider2D>();
                        C3.offset = new Vector2(0.9000006f, -0.1857142f);
                        C3.size = new Vector2(0.08571434f, 0.1428574f);

                        PolygonCollider2D Collision = Instance.AddComponent<PolygonCollider2D>();
                        List<Vector2> Polygon1 = new List<Vector2>();
                        Polygon1.Add(new Vector2(-0.5142857f, 0.1142857f));
                        Polygon1.Add(new Vector2(-0.7142857f, 0.2571429f));
                        Polygon1.Add(new Vector2(-0.8857144f, 0.2571428f));
                        Polygon1.Add(new Vector2(-1.028571f, 0.1714286f)); //setting these colliders to be different might've fucked up some contraptions but all I can hope fpr is it didn't
                        Polygon1.Add(new Vector2(-1.028571f, 0.1142857f));
                        Collision.SetPath(0, Polygon1);

                        //Finally fixed the stupid scale setting

                        ModResources.SetMass(Instance, 2.5f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("1000kg Weight"),
                    NameOverride = "10000kg Weight -QoLI",
                    NameToOrderByOverride = "1000kg Weight 2",
                    DescriptionOverride = "A weight made of highly compressed metal",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("10000kgWeightView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("10000kgWeightA.png"),
                            ModAPI.LoadSprite("10000kgWeightB.png"),
                            ModAPI.LoadSprite("10000kgWeightC.png"),
                        };
                        ModResources.SetMass(Instance, 250f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("1000kg Weight"),
                    NameOverride = "100000kg Weight -QoLI",
                    NameToOrderByOverride = "1000kg Weight 3",
                    DescriptionOverride = "A weight made of unnecessarily compressed metal",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("100000kgWeightView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("100000kgWeightA.png"),
                            ModAPI.LoadSprite("100000kgWeightB.png"),
                            ModAPI.LoadSprite("100000kgWeightC.png"),
                        };
                        ModResources.SetMass(Instance, 2500f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Shatterproof Glass Pane -QoLI",
                    NameToOrderByOverride = "Glass Pane 2",
                    DescriptionOverride = "A piece of Shatterproof glass",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("ReinforcedGlassPaneView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ReinforcedGlassPane.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        Instance.AddComponent<BoxCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Glass");
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                    NameOverride = "Bulletproof Glass Pane -QoLI",
                    NameToOrderByOverride = "Glass Pane 3",
                    DescriptionOverride = "A piece of bulletproof glass, a lot stronger than the regular",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("BulletproofGlassPaneView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BulletproofGlassPane.png");

                        ModResources.SetMass(Instance, 3f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Glass");
                        phys.AbsorbsLasers = false;
                        phys.Properties.BulletSpeedAbsorptionPower = 100f;

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        Instance.AddComponent<BoxCollider2D>();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Heavy Rod -QoLI",
                    NameToOrderByOverride = "Rod 4",
                    DescriptionOverride = "A version of the rod that's very heavy.\nThe heavier an object is the stronger the connected wires are",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    AfterSpawn = (Instance) =>
                    {
                        ModResources.SetMass(Instance, 2f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                    NameOverride = "Bulletproof Shielding -QoLI",
                    NameToOrderByOverride = "Bulletproof Sheet 2",
                    DescriptionOverride = "A version of the bulletproof sheet that's more bullet resistant",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("BulletproofShieldingView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BulletproofShielding.png");

                        ModResources.SetMass(Instance, 5f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties.BulletSpeedAbsorptionPower = 300f;

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Metal Barrel -QoLI",
                    NameToOrderByOverride = "Plastic Barrel 2",
                    DescriptionOverride = "An empty barrel made of metal",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MetalBarrelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MetalBarrel.png");

                        ModResources.SetMass(Instance, 2f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.7428551f, 1.457143f);
                        Collision1.offset = new Vector2(0.000001907349f, 0f);
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");

                        var properties = phys.Properties.ShallowClone();
                        properties.Buoyancy = 3f;
                        phys.Properties = properties;

                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                    NameOverride = "Long Clamp -QoLI",
                    NameToOrderByOverride = "Clamp 2",
                    DescriptionOverride = "An clamp that's twice the length",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("LongClampView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("LongClamp.png");

                        ModResources.SetMass(Instance, 2f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.8f, 0.1142854f);
                        Collision1.offset = new Vector2(0f, 0.1857145f);
                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.8f, 0.1142854f);
                        Collision2.offset = new Vector2(0f, -0.1857145f);

                        var childObject = new GameObject("LongClamp");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("LongClampInside.png");
                        childSprite.sortingLayerName = "Bottom";
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Map Block -QoLI",
                    NameToOrderByOverride = "Map Block A",
                    DescriptionOverride = "An item that acts like a map block once it is converted in the context menu and copied or saved",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MapBlockView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MapBlock.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        ModResources.SetMass(Instance, 1000000f);

                        Instance.layer = 9;

                        Instance.GetOrAddComponent<FreezeBehaviour>();
                        Instance.GetOrAddComponent<NoTemperature>();
                        Instance.GetOrAddComponent<MapBlockBehaviour>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        phys.Disintegratable = false;
                        phys.Properties.Flammability = 0f;
                        phys.Properties.BulletSpeedAbsorptionPower = float.MaxValue;
                        phys.SimulateTemperature = false;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Snow Map Block -QoLI",
                    NameToOrderByOverride = "Map Block B",
                    DescriptionOverride = "An item that acts like a map block once it is converted in the context menu and copied or saved",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MapBlockSnowView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MapBlockSnow.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        ModResources.SetMass(Instance, 1000000f);

                        Instance.layer = 9;

                        Instance.GetOrAddComponent<FreezeBehaviour>();
                        Instance.GetOrAddComponent<NoTemperature>();
                        Instance.GetOrAddComponent<MapBlockBehaviour>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Snow");
                        phys.Disintegratable = false;
                        phys.Properties.Flammability = 0f;
                        phys.Properties.BulletSpeedAbsorptionPower = float.MaxValue;
                        phys.SimulateTemperature = false;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Map Block Destroyer -QoLI",
                    NameToOrderByOverride = "Map Block C",
                    DescriptionOverride = "Removes this mods map blocks",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MapBlockDestroyerView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MapBlockDestroyer.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetOrAddComponent<MapBlockDestroyerBehaviour>();
                        Instance.GetOrAddComponent<NoTemperature>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();

                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        phys.ForceNoCharge = true;
                        phys.ForceNoChargeParticles = true;
                        phys.SimulateTemperature = false;
                        ModResources.SetMass(Instance, 0.05f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("I-Beam"),
                    NameOverride = "Giant Metal Bowl -QoLI",
                    NameToOrderByOverride = "Giant Wooden Bowl 2",
                    DescriptionOverride = "The giant bowl made of metal",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("GiantMetalBowlView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("GiantMetalBowlA.png"),
                            ModAPI.LoadSprite("GiantMetalBowlB.png"),
                            ModAPI.LoadSprite("GiantMetalBowlC.png"),
                            ModAPI.LoadSprite("GiantMetalBowlD.png"),
                            ModAPI.LoadSprite("GiantMetalBowlE.png"),
                        };
                        var phys = Instance.GetComponent<PhysicalBehaviour>();

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);

                        PolygonCollider2D Bowl = ModAPI.FindSpawnable("Giant Wooden Bowl").Prefab.GetComponent<PolygonCollider2D>();

                        PolygonCollider2D Polygon = Instance.GetOrAddComponent<PolygonCollider2D>();
                        Polygon.SetPath(0, Bowl.GetPath(0));
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Wheel -QoLI",
                    NameToOrderByOverride = "Wheel A",
                    DescriptionOverride = "A regular wheel",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("SmallWheelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SmallWheel.png");

                        ModResources.SetMass(Instance, 1f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        CircleCollider2D mat = Instance.AddComponent<CircleCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Rubber");

                        var properties = phys.Properties.ShallowClone();
                        properties.Buoyancy = 0.85f;
                        phys.Properties = properties;

                        if (Instance.GetComponent<CustomFrictionBehaviour>())
                            Instance.AddComponent<CustomFrictionBehaviour>();

                        PhysicsMaterial2D material = new PhysicsMaterial2D();
                        material.bounciness = 0.07f;

                        mat.sharedMaterial = material;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Car Wheel -QoLI",
                    NameToOrderByOverride = "Wheel B",
                    DescriptionOverride = "A wheel taken out of a car",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("NormalWheelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("NormalWheel.png");

                        ModResources.SetMass(Instance, 1f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        CircleCollider2D mat = Instance.AddComponent<CircleCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Rubber");

                        var properties = phys.Properties.ShallowClone();
                        properties.Buoyancy = 1f;
                        phys.Properties = properties;

                        if (Instance.GetComponent<CustomFrictionBehaviour>())
                            Instance.AddComponent<CustomFrictionBehaviour>();

                        PhysicsMaterial2D material = new PhysicsMaterial2D();
                        material.bounciness = 0.07f;

                        mat.sharedMaterial = material;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bus Wheel -QoLI",
                    NameToOrderByOverride = "Wheel C",
                    DescriptionOverride = "A wheel taken out of a bus",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MediumWheelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MediumWheel.png");

                        ModResources.SetMass(Instance, 0.7411594f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        CircleCollider2D mat = Instance.AddComponent<CircleCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Rubber");

                        var properties = phys.Properties.ShallowClone();
                        properties.Buoyancy = 1.35f;
                        phys.Properties = properties;

                        if (Instance.GetComponent<CustomFrictionBehaviour>())
                            Instance.AddComponent<CustomFrictionBehaviour>();

                        PhysicsMaterial2D material = new PhysicsMaterial2D();
                        material.bounciness = 0.07f;

                        mat.sharedMaterial = material;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Truck Wheel -QoLI",
                    NameToOrderByOverride = "Wheel D",
                    DescriptionOverride = "A wheel taken out of a truck",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("LargeWheelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("LargeWheel.png");

                        ModResources.SetMass(Instance, 1.47719f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        CircleCollider2D mat = Instance.AddComponent<CircleCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Rubber");

                        var properties = phys.Properties.ShallowClone();
                        properties.Buoyancy = 1.5f;
                        phys.Properties = properties;

                        if (Instance.GetComponent<CustomFrictionBehaviour>())
                            Instance.AddComponent<CustomFrictionBehaviour>();

                        PhysicsMaterial2D material = new PhysicsMaterial2D();
                        material.bounciness = 0.07f;

                        mat.sharedMaterial = material;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Tank Wheel -QoLI",
                    NameToOrderByOverride = "Wheel E",
                    DescriptionOverride = "A wheel taken out of a tank",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("TankWheelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("TankWheel.png");

                        ModResources.SetMass(Instance, 5f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<CircleCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");

                        if (Instance.GetComponent<CustomFrictionBehaviour>())
                            Instance.AddComponent<CustomFrictionBehaviour>();

                        var properties = phys.Properties.ShallowClone();
                        properties.Buoyancy = 0.07f;
                        phys.Properties = properties;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bicycle Wheel -QoLI",
                    NameToOrderByOverride = "Wheel F",
                    DescriptionOverride = "A wheel taken out of a bicycle",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("BicycleWheelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BicycleWheel.png");

                        ModResources.SetMass(Instance, 0.4f);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        CircleCollider2D mat = Instance.AddComponent<CircleCollider2D>();

                        var phys = Instance.GetComponent<PhysicalBehaviour>();

                        var properties = phys.Properties.ShallowClone();
                        properties.Buoyancy = 1.5f;
                        phys.Properties = properties;

                        if (Instance.GetComponent<CustomFrictionBehaviour>())
                            Instance.AddComponent<CustomFrictionBehaviour>();

                        PhysicsMaterial2D material = new PhysicsMaterial2D();
                        material.bounciness = 0.025f;

                        mat.sharedMaterial = material;

                        var Rubber = ModAPI.FindPhysicalProperties("Rubber");
                        Rubber.SoftImpact = new[]{
                            ModAPI.LoadSound("BikeSoundA.wav"),
                            ModAPI.LoadSound("BikeSoundB.wav"),
                        };
                        Rubber.HardImpact = new[]{
                            ModAPI.LoadSound("BikeSoundC.wav"),
                            ModAPI.LoadSound("BikeSoundD.wav"),
                        };
                        phys.Properties = Rubber;
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Anti Disintegration Part -QoLI",
                    NameToOrderByOverride = "Disintegration Part",
                    DescriptionOverride = "A part immune to being disintegrated",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("AntiDisintegrationPartView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AntiDisintegrationPart.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        ModResources.SetMass(Instance, 0.5f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        phys.Disintegratable = false;

                        Instance.GetOrAddComponent<AntiDisintegrationPartBehaviour>();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Tint Changer", //Lack of tag, forgor :skull:
                    NameToOrderByOverride = "ZZZZZZ",
                    DescriptionOverride = "Sets the tint of the objects it collides with to whatever specified, can also make them glow\nThis will disable metal items glowing from heat",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("TintChangerView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("TintChanger.png"); //I'm lazy as fuck and wanted to get this update out as soon as possible so I made the sprite a fucking glowing circle, similar to the info acquirer.
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<CircleCollider2D>();

                        Instance.GetOrAddComponent<ColorSetBehaviour>().Light = ModAPI.CreateLight(Instance.transform, new Color32(255, 255, 255, 255), 5f, 2f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();

                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        phys.ForceNoCharge = true;
                        phys.ForceNoChargeParticles = true;
                        phys.SimulateTemperature = false;
                        ModResources.SetMass(Instance, 0.025f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Info Acquirer",
                    NameToOrderByOverride = "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ",
                    DescriptionOverride = "Notifies you the properties of the items it collides with",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("InfoAcquirerView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("InfoAcquirer.png");
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 40);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        ModAPI.CreateLight(Instance.transform, Color.white, 1f, 0.25f);

                        Instance.GetOrAddComponent<InfoAcquirerBehaviour>();
                        Instance.GetOrAddComponent<NoTemperature>();

                        Instance.GetComponent<Rigidbody2D>().freezeRotation = true;

                        var phys = Instance.GetComponent<PhysicalBehaviour>();

                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        phys.ForceNoCharge = true;
                        phys.ForceNoChargeParticles = true;
                        phys.SimulateTemperature = false;
                        ModResources.SetMass(Instance, 0.025f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Glow Block",
                    NameToOrderByOverride = "Glow Block",
                    DescriptionOverride = "Glows a selected color",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("GlowBlockView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("GlowBlock.png");
                        Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(0, 0, 0, 255);

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetOrAddComponent<GlowBlock>().GlowSprite = ModAPI.LoadSprite("GlowBlock.png");

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        phys.ForceNoChargeParticles = true;
                        ModResources.SetMass(Instance, 1.25f);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Digital Speedometer -QoLI",
                    NameToOrderByOverride = "Speedometer",
                    DescriptionOverride = "Tells you its speed and can send an activation signal based on that.",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("SpeedometerView.png", 1f, false),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Speedometer.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<SpeedometerBehaviour>().GlowSprite = ModAPI.LoadSprite("SpeedometerGlow.png");

                        ModResources.SetMass(Instance, 1.05f);
                    }
                }
            );
            /*
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Angle Sensor -QoLI",
                    NameToOrderByOverride = "Angle Sensor",
                    DescriptionOverride = "Tells you its angle and can send an activation signal based on that.", //Totally not a copy of the last description
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("AngleSensorView.png", 1f, false),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AngleSensor.png");

                        foreach (var c in Instance.GetComponents<Collider2D>())
                            GameObject.Destroy(c);
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<AngleSensorBehaviour>().IndicationArm = ModAPI.LoadSprite("AngleSensorArm.png");

                        ModResources.SetMass(Instance, 1.675f);
                    }
                }
            );
            */
        }
    }

    public static class ModResources //Just a simpler way to set mass
    {
        public static void SetMass(GameObject Instance, float Mass)
        {
            var phys = Instance.GetComponent<PhysicalBehaviour>();
            phys.TrueInitialMass = Mass;
            phys.rigidbody.mass = Mass;
            phys.InitialMass = Mass;
        }
    }

    public class AngleSensorBehaviour : MonoBehaviour
    {
        public float MinAngle = 0f;
        public float MaxAngle = 180f;
        public bool Activated = true;
        public bool DoubleTrigger = true;

        [SkipSerialisation]
        public Sprite IndicationArm;
        [SkipSerialisation]
        public TextMeshPro Text;

        private GameObject MinimumArm;
        private GameObject MaximumArm;
        private bool OverLimit = false;

        public void Awake()
        {
            MinimumArm = new GameObject("Angle Sensor Minimum Arm", typeof(SpriteRenderer));
            MaximumArm = new GameObject("Angle Sensor Maximum Arm", typeof(SpriteRenderer));

            Text = GameObject.Instantiate(ModAPI.FindSpawnable("Thermometer").Prefab.GetComponent<ThermometerBehaviour>().TextMesh);
            ContinuousActivationBehaviour.Instance.OnContinuousUpdate.AddListener(new UnityAction<float>(OnContinuousUpdate));
        }

        public void Start()
        {
            SpriteRenderer Sprite = GetComponent<SpriteRenderer>();

            Transform MinTransform = MinimumArm.transform;
            MinTransform.SetParent(transform);
            MinTransform.localPosition = new Vector3(0f, 0f);
            MinTransform.localEulerAngles = new Vector3(0f, 0f, MinAngle);
            SpriteRenderer MinSprite = MinimumArm.GetComponent<SpriteRenderer>();
            MinSprite.sprite = IndicationArm;
            MinSprite.sortingOrder = Sprite.sortingOrder + 1;

            Transform MaxTransform = MaximumArm.transform;
            MaxTransform.SetParent(transform);
            MaxTransform.localPosition = new Vector3(0f, 0f);
            MaxTransform.localEulerAngles = new Vector3(0f, 0f, MaxAngle);
            SpriteRenderer MaxSprite = MaximumArm.GetComponent<SpriteRenderer>();
            MaxSprite.sprite = IndicationArm;
            MaxSprite.sortingOrder = Sprite.sortingOrder + 1;

            Text.name = "Angle";
            Text.text = ConvertedText;
            Text.sortingLayerID = Sprite.sortingLayerID;
            Text.sortingOrder = Sprite.sortingOrder + 1;
            Text.rectTransform.SetParent(transform);
            Text.rectTransform.anchoredPosition = transform.position;
            Text.rectTransform.sizeDelta = new Vector2(Text.rectTransform.sizeDelta.x * 2f, Text.rectTransform.sizeDelta.y);
            Text.rectTransform.transform.localPosition = new Vector3(-2f, 0f);
            Text.rectTransform.transform.localScale = new Vector2(1f * transform.localScale.x, 1f * transform.localScale.y);
            Text.rectTransform.transform.rotation = transform.rotation;
            Text.color = Color.white;
            UpdateUse();
        }

        public float RoundedAngle(float Power)
        {
            float MD = Mathf.Pow(10f, Power);
            return Mathf.Round(transform.eulerAngles.z * MD) / MD;
        }

        public string ConvertedText
        {
            get
            {
                return RoundedAngle(2f).ToString() + "";
            }
        }

        public void OnContinuousUpdate(float arg0)
        {
            if (OverLimit && Activated)
                SendMessage("IsolatedContinuousActivation", new ActivationPropagation(transform.root, 0), SendMessageOptions.DontRequireReceiver);
        }

        public void Use()
        {
            if (!this.enabled)
                return;

            Activated = !Activated;
            UpdateUse();
        }

        public void UpdateUse()
        {
            Text.enabled = Activated;
        }

        public void FixedUpdate()
        {
            if (!Activated)
            {
                OverLimit = false;
                return;
            }

            Text.text = ConvertedText;

            bool flag1 = RoundedAngle(1f) > MinAngle;
            bool flag2 = RoundedAngle(1f) < MaxAngle;

            if (OverLimit && (RoundedAngle(1f) > MinAngle && RoundedAngle(1f) < MaxAngle))
            {
                if (DoubleTrigger)
                    SendMessage("IsolatedActivation", new ActivationPropagation(transform.root, 0), SendMessageOptions.DontRequireReceiver);

                OverLimit = false;
                return;
            }

            if (!OverLimit && (RoundedAngle(1f) < MinAngle || RoundedAngle(1f) > MaxAngle))
            {
                SendMessage("IsolatedActivation", new ActivationPropagation(transform.root, 0), SendMessageOptions.DontRequireReceiver);
                OverLimit = true;
            }
        }

        public void OnDestroy()
        {
            ContinuousActivationBehaviour.Instance.OnContinuousUpdate.RemoveListener(new UnityAction<float>(OnContinuousUpdate));
        }
    }

    public class SpeedometerBehaviour : MonoBehaviour
    {
        public bool Activated = true;
        public float Speed = 0f;
        public float Threshold = 10f;
        public bool DoubleTrigger = true;
        public int UnitType = 0;

        [SkipSerialisation]
        public TextMeshPro Text;
        [SkipSerialisation]
        public Sprite GlowSprite;

        private Rigidbody2D rb;
        private bool OverLimit = false;
        private LightSprite Light;
        private GameObject Glow = new GameObject("Speed Glow");
        private SpriteRenderer GlowRenderer;

        public void Awake()
        {
            Light = ModAPI.CreateLight(transform, new Color(0f, 0.784313725f, 1f, Mathf.Clamp((Speed / Threshold), 0.01f, 1f) + 0.05f), 1f, 2.5f);
            GlowRenderer = Glow.GetOrAddComponent<SpriteRenderer>();
            Text = GameObject.Instantiate(ModAPI.FindSpawnable("Thermometer").Prefab.GetComponent<ThermometerBehaviour>().TextMesh);
            rb = GetComponent<Rigidbody2D>();
            ContinuousActivationBehaviour.Instance.OnContinuousUpdate.AddListener(new UnityAction<float>(OnContinuousUpdate));
        }

        public string ConvertedText
        {
            get
            {
                float Math = 0f;

                if (UnitType == 0) //This is a bad way to do this but I cannot be bothered to find the correct way to do it.
                {
                    if (Speed < 200f)
                        Math = 2f;

                    return string.Format("<mspace=0.057>{0} m/s", RoundedSpeed(Math).ToString());
                }

                if (UnitType == 1)
                {
                    if (Speed * 3.6f < 500f)
                        Math = 1f;

                    return string.Format("<mspace=0.057>{0} km/h", (RoundedSpeed(Math, 3.6f)).ToString());
                }
                if (UnitType == 2)
                {
                    if (Speed * 2.236936f < 350f)
                        Math = 1f;

                    return string.Format("<mspace=0.057>{0} mph", (RoundedSpeed(Math, 2.236936f)).ToString());
                }

                return "";
            }
        }

        public float RoundedSpeed(float Power, float Multiplier = 1f)
        {
            float MD = Mathf.Pow(10f, Power);
            float Speedier = Speed * Multiplier;
            float Math = ((Mathf.Round(Speedier * MD)) / MD);
            return (Math > ((1 / MD) * 2)) ? Math : 0f;
        }

        public void Start()
        {
            Transform LightTransform = Light.gameObject.transform;
            LightTransform.localScale = new Vector3(transform.localScale.x * 1.5f, transform.localScale.y);
            LightTransform.localPosition = new Vector3(0f, -0.175f);

            Transform GlowTransform = Glow.transform;
            GlowTransform.SetParent(transform);
            GlowTransform.localPosition = new Vector3(0f, 0f);
            GlowTransform.rotation = transform.rotation;

            GlowRenderer.sprite = GlowSprite;
            GlowRenderer.color = new Color(0f, 0.784313725f, 1f, Mathf.Clamp((Speed / Threshold), 0.01f, 1f) / 5f);
            GlowRenderer.material = ModAPI.FindMaterial("VeryBright");
            GlowRenderer.sortingOrder = GetComponent<SpriteRenderer>().sortingOrder + 1;
            GlowRenderer.enabled = false;

            Text.name = "Speed";
            Text.text = ConvertedText;
            Text.sortingLayerID = GetComponent<SpriteRenderer>().sortingLayerID;
            Text.sortingOrder = GetComponent<SpriteRenderer>().sortingOrder + 1;
            Text.rectTransform.SetParent(transform);
            Text.rectTransform.anchoredPosition = transform.position;
            Text.rectTransform.sizeDelta = new Vector2(Text.rectTransform.sizeDelta.x * 2f, Text.rectTransform.sizeDelta.y);
            Text.rectTransform.transform.localPosition = new Vector3(-0.45f * transform.localScale.x, 0.065f * transform.localScale.y);
            Text.rectTransform.transform.localScale = new Vector2(0.8f * transform.localScale.x, 0.8f * transform.localScale.y);
            Text.rectTransform.transform.rotation = transform.rotation;
            Text.color = Color.white;

            PhysicalBehaviour pb = GetComponent<PhysicalBehaviour>();
            pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetThreshold", "Set Speed Threshold", "Set Speed Threshold", () =>
            {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the speed that has to be\nsurpassed for an activation signal\n<size=26>Currently:" + Threshold + " m/s</size>", "Number", new DialogButton("Apply", true, new UnityAction[1]
                {
                    (UnityAction)(() =>
                    {
                        float setrange;
                        if (float.TryParse(dialog.EnteredText, out setrange))
                        {
                            if(setrange > 0f)
                            {
                                Threshold = setrange;
                                ModAPI.Notify("Set the threshold to " + Threshold + ".");
                            }
                            else
                            {
                                ModAPI.Notify("Threshold must be larger than 0.");
                                return;
                            }
                        }
                    })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));

            pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("ToggleDoubleTrigger", delegate ()
            {
                if (!DoubleTrigger)
                {
                    return "Double Trigger";
                }
                return "Single Trigger";
            }, "Toggle trigger behaviour", new UnityAction[]
             {
                delegate()
                {
                    DoubleTrigger = !DoubleTrigger;
                }
            }));

            pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("ChangeUnit", delegate ()
            {
                if (UnitType == 0)
                    return "Current Unit: m/s";
                if (UnitType == 1)
                    return "Current Unit: km/h";
                return "Current Unit: mph";
            }, "Switch between the units of speed.", new UnityAction[]
             {
                delegate()
                {
                    UnitType++;
                    if(UnitType > 2)
                        UnitType = 0;
                    Text.text = ConvertedText;
                }
            }));

            UpdateUse();
        }

        public void Use()
        {
            if (!this.enabled)
                return;

            Activated = !Activated;
            UpdateUse();
        }

        public void UpdateUse()
        {
            Light.enabled = Activated;
            GlowRenderer.enabled = Activated;
            Text.enabled = Activated;
        }

        public void OnContinuousUpdate(float arg0)
        {
            if (!OverLimit && Activated)
                SendMessage("IsolatedContinuousActivation", new ActivationPropagation(transform.root, 0), SendMessageOptions.DontRequireReceiver);
        }

        public void FixedUpdate()
        {
            if (!Activated)
            {
                OverLimit = false;
                return;
            }

            Speed = rb.velocity.magnitude / 1.2136f; //Did a little testing and found out that 1 meter in game is approximately 1.2136f.
            GlowRenderer.color = new Color(0f, 0.784313725f, 1f, Mathf.Clamp((Speed / Threshold), 0.01f, 1f) / 5f);
            Color color = Light.Color;
            color.a = Mathf.Clamp((Speed / Threshold), 0.01f, 1f) + 0.05f;
            Light.Color = color;
            Text.text = ConvertedText;

            if (!OverLimit && RoundedSpeed(1f) < Threshold)
            {
                if (DoubleTrigger)
                    SendMessage("IsolatedActivation", new ActivationPropagation(transform.root, 0), SendMessageOptions.DontRequireReceiver);

                OverLimit = true;
                return;
            }

            if (OverLimit && RoundedSpeed(1f) > Threshold)
            {
                SendMessage("IsolatedActivation", new ActivationPropagation(transform.root, 0), SendMessageOptions.DontRequireReceiver);
                OverLimit = false;
            }
        }

        public void OnDestroy()
        {
            ContinuousActivationBehaviour.Instance.OnContinuousUpdate.RemoveListener(new UnityAction<float>(OnContinuousUpdate));
        }
    }

    public class AntiDisintegrationPartBehaviour : MonoBehaviour
    {
        public bool Deletable = false;

        [SkipSerialisation]
        public PhysicalBehaviour pb;

        public void Start()
        {
            pb = GetComponent<PhysicalBehaviour>();
            pb.Deletable = Deletable;

            pb.ContextMenuOptions.Buttons.Add(new ContextMenuButton("ToggleDeletable", delegate ()
            {
                if (!Deletable)
                {
                    return "Undeletable";
                }
                return "Deletable";
            }, "Toggle whether the item can be deleted without clearing the map", new UnityAction[]
             {
                delegate()
                {
                    Deletable = !Deletable;
                    pb.Deletable = Deletable;
                }
            }));
        }
    }

    public class MapBlockDestroyerBehaviour : MonoBehaviour
    {
        public Vector2 barrelDirection = Vector2.right;
        LineRenderer Aim;

        public Vector2 BarrelDirection => transform.TransformDirection(barrelDirection) * transform.localScale.x;

        [SkipSerialisation]
        LayerMask Mask;
        [SkipSerialisation]
        public LightSprite Light;

        void Start()
        {
            Mask = LayerMask.GetMask(LayerMask.LayerToName(9), LayerMask.LayerToName(13), LayerMask.LayerToName(11));
            Light = ModAPI.CreateLight(gameObject.transform, new Color32(255, 255, 255, 255), 3f, 1f);
            Aim = gameObject.AddComponent<LineRenderer>();
            Aim.startColor = new Color(1f, 1f, 1f, 0.01f);
            Aim.endColor = new Color(1f, 1f, 1f, 0.01f);
            Aim.startWidth = 0.01f;
            Aim.endWidth = 0.01f;
            Aim.material = ModAPI.FindMaterial("VeryBright");
        }

        public void Use()
        {
            Shoot();
        }

        void Shoot()
        {
            RaycastHit2D Ray = Physics2D.Raycast(transform.position, BarrelDirection, Mathf.Infinity, Mask);
            if (Ray.collider == null)
                return;

            GameObject RayObject = Ray.collider.gameObject;

            if (RayObject.layer == 11 && RayObject.GetComponent<MapBlockBehaviour>())
                UnityEngine.Object.Destroy(RayObject);
        }

        void Update()
        {
            RaycastHit2D Ray = Physics2D.Raycast(transform.position, BarrelDirection, Mathf.Infinity, Mask);
            Light.transform.position = Ray.point;
            Aim.SetPosition(0, transform.position);
            Aim.SetPosition(1, Ray.point);
        }
    }

    public class MuteSave : MonoBehaviour
    {
        AudioSource[] Audios;
        public void Start()
        {
            Audios = GetComponents<AudioSource>();

            if (Audios == null || Audios.Length == 0)
                UnityEngine.Object.Destroy(this);

            foreach (var Audio in Audios)
            {
                Audio.mute = true;
            }
        }

        public void Update()
        {
            foreach (var Audio in Audios)
            {
                Audio.mute = true;
            }
        }

        public void OnDisable()
        {
            foreach (var Audio in Audios)
            {
                Audio.mute = false;
            }
        }
    }

    public class MutingPower : ToolBehaviour
    {
        public override void OnToolChosen()
        {
        }

        public override void OnToolUnchosen()
        {
        }

        public override void OnSelect()
        {
            if (!ActiveSingleSelected)
                return;

            GameObject Audio = ActiveSingleSelected.gameObject;

            if (Audio.GetComponent<MuteSave>())
            {
                Destroy(Audio.GetComponent<MuteSave>());

                if (Input.GetKey(KeyCode.LeftShift))
                {
                    foreach (MuteSave Mute in Audio.transform.root.GetComponentsInChildren<MuteSave>())
                        Destroy(Mute);
                }
                return;
            }

            Audio.AddComponent<MuteSave>();

            if (Input.GetKey(KeyCode.LeftShift))
            {
                foreach (AudioSource Sound in Audio.transform.root.GetComponentsInChildren<AudioSource>())
                {
                    GameObject Object = Sound.gameObject;
                    if (!Object.GetComponent<MuteSave>())
                        Object.AddComponent<MuteSave>();
                }
            }
        }

        public override void OnHold()
        {
        }

        public override void OnFixedHold()
        {
        }

        public override void OnDeselect()
        {
        }
    }

    public class InvisibleSave : MonoBehaviour
    {
        private SpriteRenderer Sprite;
        private Color c;

        private float Opacity = 1f;

        public void Awake()
        {
            Sprite = GetComponent<SpriteRenderer>();

            if (Sprite == null)
                UnityEngine.Object.Destroy(this);

            Opacity = Sprite.color.a;
            c = Sprite.color;
            c.a = 0f;
            Sprite.color = c;
            Sprite.enabled = false;
        }

        public void Update()
        {
            Sprite.enabled = false;
            Sprite.color = c;
        }

        public void OnDisable()
        {
            c.a = Opacity;
            Sprite.color = c;

            Sprite.enabled = true;
        }
    }

    public class InvisiblePower : ToolBehaviour
    {
        public override void OnToolChosen()
        {
        }

        public override void OnToolUnchosen()
        {
        }

        public override void OnSelect()
        {
            if (!ActiveSingleSelected)
                return;

            GameObject Visible = ActiveSingleSelected.gameObject;

            if (Visible.GetComponent<InvisibleSave>())
            {
                Destroy(Visible.GetComponent<InvisibleSave>());
                List<InvisibleSave> List = Visible.transform.root.GetComponentsInChildren<InvisibleSave>().ToList();
                int Count = 1;

                if (Input.GetKey(KeyCode.LeftShift))
                {
                    Count = 0;
                    foreach (InvisibleSave Invis in List)
                        if (Invis.gameObject.GetComponent<Rigidbody2D>())
                        {
                            Destroy(Invis);
                            Count++;
                        }
                }

                if (Count == 1)
                    ModAPI.Notify("Made an object visible.");
                else
                    ModAPI.Notify("Made " + Count + " objects visible.");
                return;
            }

            int Length = 1;

            Visible.AddComponent<InvisibleSave>();

            if (Input.GetKey(KeyCode.LeftShift))
            {
                List<SpriteRenderer> List = Visible.transform.root.GetComponentsInChildren<SpriteRenderer>().ToList();

                foreach (SpriteRenderer Sprite in List)
                {
                    GameObject Object = Sprite.gameObject;
                    if (!Object.GetComponent<InvisibleSave>() && Object.GetComponent<Rigidbody2D>())
                    {
                        Object.AddComponent<InvisibleSave>();
                        Length++;
                    }
                }
            }

            if (Length == 1)
                ModAPI.Notify("Made an object invisible.");
            else
                ModAPI.Notify("Made " + Length + " objects invisible.");
        }

        public override void OnHold()
        {
        }

        public override void OnFixedHold()
        {
        }

        public override void OnDeselect()
        {
        }
    }

    public class GlowBlock : MonoBehaviour //Edited glow battery code
    {
        public bool Activated = false;
        public float Bright = 2f;
        public Vector3 Scale = new Vector3(1f, 1f);
        public Vector3 Offset = new Vector3(0f, 0f);

        public Color32 Colour = new Color32((byte)UnityEngine.Random.Range(0, 255), (byte)UnityEngine.Random.Range(0, 255), (byte)UnityEngine.Random.Range(0, 255), (byte)UnityEngine.Random.Range(55, 255));

        [SkipSerialisation]
        public GameObject Glow = new GameObject("Glow");
        [SkipSerialisation]
        public Sprite GlowSprite;
        [SkipSerialisation]
        public LightSprite Light;
        [SkipSerialisation]
        public PhysicalBehaviour phys;

        public void UpdateGlowSprite()
        {
            Light.Color = new Color32(Colour.r, Colour.g, Colour.b, 255);
            Light.Brightness = Bright;
            Light.transform.localScale = Scale;
            Light.transform.localPosition = Offset;

            if (Activated)
            {
                Light.Brightness = Bright;
                Glow.GetComponent<SpriteRenderer>().color = Colour;
            }
            else
            {
                Light.Brightness = 0f;
                Glow.GetComponent<SpriteRenderer>().color = new Color32(Colour.r, Colour.g, Colour.b, 0);
            }
        }

        void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();

            Glow.transform.parent = gameObject.transform;
            Glow.transform.rotation = gameObject.transform.rotation;
            Glow.transform.localPosition = new Vector3(0f, 0f);
            Glow.transform.localScale = new Vector3(1f, 1f);

            var Sprite = Glow.GetOrAddComponent<SpriteRenderer>();
            Sprite.sprite = GlowSprite;
            Sprite.material = ModAPI.FindMaterial("VeryBright");
            Sprite.color = new Color32(0, 0, 0, 0);
            Sprite.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;

            Light = ModAPI.CreateLight(gameObject.transform, new Color32(Colour.r, Colour.g, Colour.b, 255), 3f, 0f);

            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetBrightness", "Set Light Brightness", "Set Light Brightness", () =>
            {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the brightness of the light\n<size=26>Currently:" + Bright + "</size>", "Number", new DialogButton("Apply", true, new UnityAction[1]
                {
                    (UnityAction)(() =>
                    {
                        float setrange;
                        if (float.TryParse(dialog.EnteredText, out setrange))
                        {
                            Bright = setrange;
                              UpdateGlowSprite();
                        }
                    })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));

            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetOffset", "Set Light Offset", "Set Light Offset", () =>
            {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Set the offset of the light from the center of the item (x, y)\n" + "Current offset = " + Offset.x + ", " + Offset.y, "Example:" + UnityEngine.Random.Range(1, 10) + ", " + UnityEngine.Random.Range(1, 10), new DialogButton("Apply", true, new UnityAction[1]
                {
                    (UnityAction)(() =>
                    {
                        string[] Text = dialog.EnteredText.Split(", "[0]);
                        Vector3 SetOffset = new Vector3();
                        if(Text.Length == 2)
                        {
                            SetOffset.x = float.Parse(Text[0]);
                            SetOffset.y = float.Parse(Text[1]);
                            Offset = new Vector3(SetOffset.x, SetOffset.y, 1f);
                            ModAPI.Notify("Set offset to " + Offset.x + ", " + Offset.y);
                            UpdateGlowSprite();
                        }
                        else
                        {
                            ModAPI.Notify("<color=red>Error, try using the example and tweaking it</color>");
                        }
                    })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));

            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetScale", "Set Light Scale", "Set Light Scale", () =>
            {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Set the scale of the light (x, y)\n" + "Current scale = " + Scale.x + ", " + Scale.y, "Example:" + UnityEngine.Random.Range(1, 10) + ", " + UnityEngine.Random.Range(1, 10), new DialogButton("Apply", true, new UnityAction[1]
                {
                    (UnityAction)(() =>
                    {
                        string[] Text = dialog.EnteredText.Split(", "[0]);
                        Vector3 SetScale = new Vector3();
                        if(Text.Length == 2)
                        {
                            SetScale.x = float.Parse(Text[0]);
                            SetScale.y = float.Parse(Text[1]);
                            Scale = new Vector3(SetScale.x, SetScale.y, 1f);
                            ModAPI.Notify("Set scale to " + Scale.x + ", " + Scale.y);
                            UpdateGlowSprite();
                        }
                        else
                        {
                            ModAPI.Notify("<color=red>Error, try using the example and tweaking it</color>");
                        }
                    })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));

            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetColor", "Set Color", "Set Color", () =>
            {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Set the color\n" + "<color=" + "#" + ColorUtility.ToHtmlStringRGBA(new Color32(Colour.r, Colour.g, Colour.b, 255)) + ">Current Color = " + Colour.r + ", " + Colour.g + ", " + Colour.b + ", " + Colour.a + "</color>", "Example:" + UnityEngine.Random.Range(0, 255) + ", " + UnityEngine.Random.Range(0, 255) + ", " + UnityEngine.Random.Range(0, 255) + ", " + UnityEngine.Random.Range(0, 255), new DialogButton("Apply", true, new UnityAction[1]
                {
                    (UnityAction)(() =>
                    {
                        string[] Text = dialog.EnteredText.Split(", "[0]);
                        Color32 SetColor = new Color32();
                        if(Text.Length == 4)
                        {
                            SetColor.r = byte.Parse(Text[0]);
                            SetColor.g = byte.Parse(Text[1]);
                            SetColor.b = byte.Parse(Text[2]);
                            SetColor.a = byte.Parse(Text[3]);
                            Colour = SetColor;
                            ModAPI.Notify("Set color to " + "<color=" + "#"+ColorUtility.ToHtmlStringRGBA(new Color32(Colour.r, Colour.g, Colour.b, 255)) + ">" + dialog.EnteredText + "</color>");
                            UpdateGlowSprite();
                        }
                        else
                        {
                            ModAPI.Notify("<color=red>Error, try using the example and tweaking it</color>");
                        }
                    })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));

            UpdateGlowSprite();
        }

        void Use()
        {
            Activated = !Activated;
            UpdateGlowSprite();
        }
    }

    public class CustomGlowBattery : MonoBehaviour //This took me some time, mainly realising that code order matters in some cases.
    {
        public bool Activated = false;
        public Color32 Colour;
        public float TargetCharge = 95f;
        public Sprite GlowSprite;
        [SkipSerialisation]
        public LightSprite Light;
        [SkipSerialisation]
        public GameObject Glow = new GameObject("BatteryGlow");

        public void UpdateGlow()
        {
            if (Activated)
            {
                Light.Brightness = 2f;
                Glow.GetComponent<SpriteRenderer>().color = Colour;
            }
            else
            {
                Light.Brightness = 0f;
                Glow.GetComponent<SpriteRenderer>().color = new Color32(0, 0, 0, 0);
            }
        }

        void Start()
        {
            Glow.transform.parent = gameObject.transform;
            Glow.transform.rotation = gameObject.transform.rotation;
            Glow.transform.localPosition = new Vector3(0f, 0f);
            Glow.transform.localScale = new Vector3(1f, 1f);

            var Sprite = Glow.GetOrAddComponent<SpriteRenderer>();
            Sprite.sprite = GlowSprite;
            Sprite.material = ModAPI.FindMaterial("VeryBright");
            Sprite.color = new Color32(0, 0, 0, 0);
            Sprite.sortingOrder = gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;

            Light = ModAPI.CreateLight(gameObject.transform, new Color32(Colour.r, Colour.g, Colour.b, 255), 3f, 0f);
            UpdateGlow();
        }

        void Use()
        {
            Activated = !Activated;
            UpdateGlow();
        }

        void Update()
        {
            if (Activated)
            {
                gameObject.GetComponent<PhysicalBehaviour>().Charge = TargetCharge;
            }
            else
            {
                gameObject.GetComponent<PhysicalBehaviour>().Charge = 0f;
            }
        }
    }

    public class ColorSave : MonoBehaviour
    {
        public Color32 colour;
        public bool glow = false;

        void Start()
        {
            gameObject.GetComponent<SpriteRenderer>().color = colour;
            if (glow)
            {
                gameObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
            }
            else
            {
                gameObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
            }
        }
    }

    public class ColorSetBehaviour : MonoBehaviour //pretty basic code
    {
        public Color32 Color = new Color32((byte)UnityEngine.Random.Range(0, 255), (byte)UnityEngine.Random.Range(0, 255), (byte)UnityEngine.Random.Range(0, 255), (byte)UnityEngine.Random.Range(100, 255));
        public bool Glow = false;

        [SkipSerialisation]
        public LightSprite Light;

        public void GameObjectRecolor(Color32 color)
        {
            Light.Color = new Color32(color.r, color.g, color.b, 255);
            gameObject.GetComponent<SpriteRenderer>().color = new Color32(color.r, color.g, color.b, 75);
        }

        void Start()
        {
            GameObjectRecolor(Color);

            var phys = GetComponent<PhysicalBehaviour>();
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetColor", "Set Color", "Set Color", () =>
            {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Set the color\n" + "<color=" + "#" + ColorUtility.ToHtmlStringRGBA(new Color32(Color.r, Color.g, Color.b, 255)) + ">Current Color = " + Color.r + ", " + Color.g + ", " + Color.b + ", " + Color.a + "</color>", "Example:" + UnityEngine.Random.Range(0, 255) + ", " + UnityEngine.Random.Range(0, 255) + ", " + UnityEngine.Random.Range(0, 255) + ", " + UnityEngine.Random.Range(0, 255), new DialogButton("Apply", true, new UnityAction[1]
                {
                    (UnityAction)(() =>
                    {
                        string[] Text = dialog.EnteredText.Split(", "[0]);
                        Color32 SetColor = new Color32();
                        if(Text.Length == 4)
                        {
                            SetColor.r = byte.Parse(Text[0]);
                            SetColor.g = byte.Parse(Text[1]);
                            SetColor.b = byte.Parse(Text[2]);
                            SetColor.a = byte.Parse(Text[3]);
                            Color = SetColor;
                            ModAPI.Notify("Set color to " + "<color=" + "#"+ColorUtility.ToHtmlStringRGBA(new Color32(Color.r, Color.g, Color.b, 255)) + ">" + dialog.EnteredText + "</color>");
                            GameObjectRecolor(SetColor);
                        }
                        else
                        {
                            ModAPI.Notify("<color=red>Error, try using the example and tweaking it</color>");
                        }
                    })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));

            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("ToggleGlow", delegate ()
            {
                if (!Glow)
                {
                    return "Glow: False";
                }
                return "Glow: True";
            }, "Toggle whether the item collided with should glow", new UnityAction[]
             {
                delegate()
                {
                    Glow = !Glow;
                }
            }));
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject.layer == 11 || other.gameObject.GetComponent<ColorSetBehaviour>() != null || other.gameObject.GetComponent<GlowBlock>() != null)
                return;

            foreach (var Other in other.gameObject.transform.root.gameObject.GetComponentsInChildren<Rigidbody2D>())
            {
                Other.gameObject.GetComponent<SpriteRenderer>().color = Color;
                Other.gameObject.GetOrAddComponent<ColorSave>().colour = Color; //bri'ish
                if (Glow)
                {
                    Other.gameObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                    Other.gameObject.GetComponent<ColorSave>().glow = true;
                }
                else
                {
                    Other.gameObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default"); //this part disables the ability of metal items glowing from heat but makes the metal items able to have their color changed at all
                    Other.gameObject.GetComponent<ColorSave>().glow = false;
                }
            }
        }
    }

    public class PhaseLinkToolDetailed : LinkDeviceTool //Not my code, aspa owns this. And technically zooi.
    {
        private void Awake()
        {
            WireMaterial = Resources.Load<Material>("Materials/PhaseLink");
            WireWidth = 0.08f;
            WireColor = Color.white;
        }
        protected override void OnLinkCreate(Vector2 localFrom, Vector2 localTo, PhysicalBehaviour a, PhysicalBehaviour b)
        {
            PhaseLinkBehaviourDetailed phaseLinkBehaviour = a.gameObject.AddComponent<PhaseLinkBehaviourDetailed>();
            UndoControllerBehaviour.RegisterAction(new ObjectCreationAction(phaseLinkBehaviour, "Invisible phase link"));
            phaseLinkBehaviour.Other = b;
            phaseLinkBehaviour.LocalOffset = localFrom;
            phaseLinkBehaviour.OtherLocalOffset = localTo;
        }
    }

    public class PhaseLinkBehaviourDetailed : LinkDeviceBehaviour
    {
        private void Update()
        {
            if (Global.main.GetPausedMenu())
            {
                return;
            }
            if (!fromSpriteRenderer || !toSpriteRenderer)
            {
                UnityEngine.Object.Destroy(this);
                return;
            }
            lineRenderer.enabled = Global.main.ShowLimbStatus;
            fromSpriteRenderer.enabled = Global.main.ShowLimbStatus; //These two lines is literally all I really changed.
            toSpriteRenderer.enabled = Global.main.ShowLimbStatus; //Pretty stupid, right?
            if (Global.main.ShowLimbStatus) //Guess I don't feel as bad doing this then
            {
                lineRenderer.SetPosition(0, transform.TransformPoint(LocalOffset));
                lineRenderer.SetPosition(1, Other.transform.TransformPoint(OtherLocalOffset));
            }
            CheckMouseInput();
        }

        protected override void AfterInitialise()
        {
            foreach (Collider2D collider2D in PhysicalBehaviour.transform.root.GetComponentsInChildren<Collider2D>())
            {
                foreach (Collider2D collider2D2 in Other.transform.root.GetComponentsInChildren<Collider2D>())
                {
                    if (!(collider2D == collider2D2))
                    {
                        IgnoreCollisionStackController.RequestIgnoreCollision(collider2D, collider2D2);
                    }
                }
            }
        }
        protected override void OnDestroy()
        {
            if (PhysicalBehaviour && Other)
            {
                foreach (Collider2D collider2D in PhysicalBehaviour.transform.root.GetComponentsInChildren<Collider2D>())
                {
                    foreach (Collider2D collider2D2 in Other.transform.root.GetComponentsInChildren<Collider2D>())
                    {
                        if (!(collider2D == collider2D2))
                        {
                            IgnoreCollisionStackController.RequestDontIgnoreCollision(collider2D, collider2D2);
                        }
                    }
                }
            }
            base.OnDestroy();
        }
        protected override Sprite GetDeviceSprite()
        {
            return Resources.Load<Sprite>("Sprites/PhaseLink");
        }
        protected override Color GetWireColor()
        {
            return Color.white;
        }
        protected override Material GetWireMaterial()
        {
            return Resources.Load<Material>("Materials/PhaseLink");
        }
        protected override float GetWireWidth()
        {
            return 0.08f;
        }
    }

    public class StrongRopeTool : DistanceWireTool
    {
        private void Awake()
        {
            WireMaterial = Resources.Load<Material>("Materials/Rope");
            WireColor = Color.white;
        }

        protected override void OnJointCreate(DistanceJoint2D joint)
        {
            RopeBehaviour ropeBehaviour = joint.gameObject.AddComponent<RopeBehaviour>();
            UndoControllerBehaviour.RegisterAction((IUndoableAction)new ObjectCreationAction((UnityEngine.Object)ropeBehaviour, "strong rope"));
            ropeBehaviour.WireColor = WireColor;
            ropeBehaviour.WireMaterial = WireMaterial;
            ropeBehaviour.WireWidth = WireWidth;
            ropeBehaviour.typedJoint = joint;
            ropeBehaviour.typedJoint.breakForce = Utils.CalculateBreakForceForCable((AnchoredJoint2D)joint, 3500f, 1f, 0.5f);
            ropeBehaviour.Joint_Anchor = joint.anchor;
            ropeBehaviour.Joint_ConnectedAnchor = joint.connectedAnchor;
        }
    }

    public class StrongSteelBehaviour : FixedJointWireBehaviour
    {
        [SkipSerialisation]
        protected AudioSource audioSource;
        [SkipSerialisation]
        protected AudioClip[] stress;
        protected float breakForceBuffer = 1f;

        public override int GetVertexCount() => 1;

        public override void Slice() => breakForceBuffer = 0.0f;

        protected override void Start()
        {
            base.Start();
            breakForceBuffer = currentBreakingForce;
        }

        protected override void JointBroken()
        {
            GameObject gameObject = new GameObject("steel break effect");
            gameObject.transform.position = transform.position;
            gameObject.AddComponent<DeleteAfterTime>().Life = 4f;
            gameObject.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            AudioSource audioSource = gameObject.AddComponent<AudioSource>();
            audioSource.loop = false;
            audioSource.spatialBlend = 1f;
            audioSource.dopplerLevel = 0.0f;
            audioSource.playOnAwake = false;
            audioSource.PlayOneShot(((IList<AudioClip>)Resources.LoadAll<AudioClip>("Audio/steel break")).PickRandom<AudioClip>(), UnityEngine.Random.value);
        }

        protected override void Created()
        {
            stress = Resources.LoadAll<AudioClip>("Audio/metal stress/");
            audioSource = lineRenderer.gameObject.AddComponent<AudioSource>();
            lineRenderer.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            audioSource.loop = false;
            audioSource.spatialBlend = 1f;
            audioSource.dopplerLevel = 0.0f;
            audioSource.playOnAwake = false;
            lineRenderer.numCapVertices = 0;
            lineRenderer.sortingLayerName = "Background";
            lineRenderer.textureMode = LineTextureMode.Tile;
        }

        protected override void Tick()
        {
            if ((double)UnityEngine.Random.value > 0.999499976634979 && (double)typedJoint.reactionForce.magnitude / (double)typedJoint.breakForce > 0.200000002980232)
                audioSource.PlayOneShot(((IList<AudioClip>)stress).PickRandom<AudioClip>(), 0.5f);
            float a = 0.0f;
            if ((bool)(UnityEngine.Object)physicalBehaviour)
                a = physicalBehaviour.BurnProgress;
            if ((bool)(UnityEngine.Object)otherPhysicalBehaviour)
                a = Mathf.Max(a, otherPhysicalBehaviour.BurnProgress);
            typedJoint.breakForce = breakForceBuffer * (1f - a);
        }
    }

    public class StrongestSteelBindingTool : FixedWireTool
    {
        private void Awake()
        {
            WireMaterial = Resources.Load<Material>("Materials/SteelBinding");
            WireWidth = 0.1f;
            WireColor = Color.white;
        }

        protected override void OnJointCreate(FixedJoint2D joint, Vector2 worldSpaceEndpos)
        {
            StrongSteelBehaviour bindingBehaviour = joint.gameObject.AddComponent<StrongSteelBehaviour>();
            UndoControllerBehaviour.RegisterAction((IUndoableAction)new ObjectCreationAction((UnityEngine.Object)bindingBehaviour, "strongest steel binding"));
            bindingBehaviour.WireMaterial = WireMaterial;
            bindingBehaviour.WireWidth = WireWidth;
            bindingBehaviour.typedJoint = joint;
            bindingBehaviour.typedJoint.breakForce = Utils.CalculateBreakForceForCable((AnchoredJoint2D)joint, 60000f);
            bindingBehaviour.typedJoint.breakTorque = Utils.CalculateBreakForceForCable((AnchoredJoint2D)joint, 60000f);
            if ((bool)(UnityEngine.Object)joint.connectedBody)
                bindingBehaviour.localRenderEndpoint = (Vector2)joint.connectedBody.transform.InverseTransformPoint((Vector3)worldSpaceEndpos);
            else
                bindingBehaviour.localRenderEndpoint = (Vector2)joint.transform.InverseTransformPoint((Vector3)worldSpaceEndpos);
        }
    }

    public class StrongSteelBindingTool : FixedWireTool
    {
        private void Awake()
        {
            WireMaterial = Resources.Load<Material>("Materials/SteelBinding");
            WireWidth = 0.1f;
            WireColor = Color.white;
        }

        protected override void OnJointCreate(FixedJoint2D joint, Vector2 worldSpaceEndpos)
        {
            StrongSteelBehaviour bindingBehaviour = joint.gameObject.AddComponent<StrongSteelBehaviour>();
            UndoControllerBehaviour.RegisterAction((IUndoableAction)new ObjectCreationAction((UnityEngine.Object)bindingBehaviour, "strong steel binding"));
            bindingBehaviour.WireMaterial = WireMaterial;
            bindingBehaviour.WireWidth = WireWidth;
            bindingBehaviour.typedJoint = joint;
            bindingBehaviour.typedJoint.breakForce = Utils.CalculateBreakForceForCable((AnchoredJoint2D)joint, 30000f);
            bindingBehaviour.typedJoint.breakTorque = Utils.CalculateBreakForceForCable((AnchoredJoint2D)joint, 30000f);
            if ((bool)(UnityEngine.Object)joint.connectedBody)
                bindingBehaviour.localRenderEndpoint = (Vector2)joint.connectedBody.transform.InverseTransformPoint((Vector3)worldSpaceEndpos);
            else
                bindingBehaviour.localRenderEndpoint = (Vector2)joint.transform.InverseTransformPoint((Vector3)worldSpaceEndpos);
        }
    }

    public class NoTemperature : MonoBehaviour
    {
        public void Update()
        {
            gameObject.GetComponent<PhysicalBehaviour>().Temperature = 20f;
        }
    }

    public class InfoAcquirerBehaviour : MonoBehaviour
    {
        public void OnCollisionEnter2D(Collision2D other)
        {
            var phys = other.gameObject.GetComponent<PhysicalBehaviour>();
            ModAPI.Notify("Name = " + other.gameObject.name);
            ModAPI.Notify("Mass = " + other.gameObject.GetComponent<Rigidbody2D>().mass + "(" + other.gameObject.GetComponent<Rigidbody2D>().mass * 40f + "kg)");
            ModAPI.Notify("Buoyancy = " + phys.Properties.Buoyancy);
            ModAPI.Notify("Brittleness =" + phys.Properties.Brittleness);
            ModAPI.Notify("Softness = " + phys.Properties.Softness);
            ModAPI.Notify("BulletSpeedAbsorptionPower = " + phys.Properties.BulletSpeedAbsorptionPower);
            ModAPI.Notify("Charge = " + phys.Charge);
            ModAPI.Notify("Properties = " + phys.Properties);
        }
    }

    public class MapBlockBehaviour : MonoBehaviour
    {
        public bool ChangeIntoMap = false;
        [SkipSerialisation]
        public PhysicalBehaviour phys;
        void Start()
        {
            phys = GetComponent<PhysicalBehaviour>();

            if (ChangeIntoMap)
            {
                gameObject.layer = 11;
                phys.Deletable = false;
            }

            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("MakeMapBlock", "Make map block", "Makes the objects act like the map once the item is copied or saved.", () =>
            {
                ChangeIntoMap = true;
            }));
        }
    }

    public class SeparatorBehaviour : MonoBehaviour
    {
        void Use()
        {
            Destroy(gameObject);
        }
    }

    public class CustomFrictionBehaviour : MonoBehaviour
    {
        [SkipSerialisation]
        public PhysicalBehaviour phys;
        [SkipSerialisation]
        public PhysicsMaterial2D material = new PhysicsMaterial2D();

        public float CurrentFriction = 0.4f;
        void Start()
        {
            CircleCollider2D Mat = gameObject.GetComponent<CircleCollider2D>();
            PhysicsMaterial2D material = new PhysicsMaterial2D();

            material.friction = CurrentFriction;

            Mat.sharedMaterial = material;

            phys = gameObject.GetComponent<PhysicalBehaviour>();

            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("SetFriction", "Set Friction", "Set Friction", () =>
            {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.TextEntry("Enter the friction\n<color=green><size=26>Currently:" + CurrentFriction + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1] {
                  (UnityAction)(() => {
                    float setrange;
                    if (float.TryParse(dialog.EnteredText, out setrange)) {
                      CurrentFriction = setrange;
                      material.friction = CurrentFriction;
                      Mat.sharedMaterial = material;
                    }
                  })
                }),
                new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
            }));
        }
    }
}